unit Firefly.MacOS.ClassHelpers;

{$mode Delphi}{$H+}
{$modeswitch objectivec1}
{$modeswitch typehelpers}

interface

uses
   Classes,
   SysUtils,
   Graphics,
   NSHelpers,
   CocoaAll;

type

  { TStringToNSStringHelper }

  TStringToNSStringHelper = type helper for string
     function ToNSString: NSString;
     procedure FromNSString(AString: NSString);
  end;

  { TMemoryStreamHelper }

  TMemoryStreamHelper = class helper for TMemoryStream
     function ToNSData: NSData;
     procedure FromNSData(TheData: NSData);
  end;

  { TBitmapNSImageHelper }

  TBitmapNSImageHelper = class helper for TBitmap
     function ToNSImage: NSImage;
  end;

implementation

{ TStringToNSStringHelper }

function TStringToNSStringHelper.ToNSString: NSString;
begin
   Result := NSSTR(Self);
end;

procedure TStringToNSStringHelper.FromNSString(AString: NSString);
begin
   Self := NSStrToStr(AString);
end;

{ TStreamHelper }

function TMemoryStreamHelper.ToNSData: NSData;
begin
   Result := NSData.dataWithBytes_length(Self.Memory, Self.Size);
end;

procedure TMemoryStreamHelper.FromNSData(TheData: NSData);
begin
   // untested!
   Self.SetSize(0);
   Self.Write(TheData.bytes^, TheData.length);
end;

{ TBitmapNSImageHelper }

function TBitmapNSImageHelper.ToNSImage: NSImage;
var
  ms: TMemoryStream;
begin
   ms := TMemoryStream.Create;
   try
      Self.SaveToStream(ms);
      Result := NSImage.alloc.initWithData(ms.ToNSData);
   finally
      ms.Free;
   end;
end;

end.

