unit Unit1;

{$mode objfpc}{$H+}
{$modeswitch objectivec1}
interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, EditBtn,
  ValEdit, ActnList, DateTimePicker, CocoaAll, EventKit, DateUtils,Firefly.MacOS.Toolbar;

type

  { TCalendarInfo }

  TCalendarInfo = record
    Identifier: string;
    Title: string;
  end;

type

  { TForm1 }

  TForm1 = class(TForm)
    AddCalendarEntry: TAction;
    ActionList1: TActionList;
    Button1: TButton;
    Button2: TButton;
    btnShowCalendar: TButton;
    ComboBox1: TComboBox;
    DateTimePicker1: TDateTimePicker;
    DateTimePicker2: TDateTimePicker;
    EdEventName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ListBox1: TListBox;
    Memo1: TMemo;
    procedure AddCalendarEntryExecute(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btnShowCalendarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    CalendarInfo: TCalendarInfo;

    CombinedDateTime: TDateTime;

    store: EKEventStore;
    handler: EKEventStoreRequestAccessCompletionHandler;
    procedure AccessCompletionHandler(granted: boolean; error: NSError);
    procedure addEvent;
    procedure addToolbar;
    procedure CombineDateAndTime;
    procedure ShowAvailableCalendars;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


{
// step 4: create an event
let eventStore = EKEventStore()
let event = EKEvent(eventStore: eventStore)
let endDate = Date.init(timeInterval: 3600, since: Date())
event.calendar = eventStore.defaultCalendarForNewEvents
event.title = "New Calendar Event"
event.startDate = Date()
event.endDate = endDate

do {
  try eventStore.save(event, span: .thisEvent)
} catch {
  print("saving event error: \(error)")
}
 }

procedure TForm1.CombineDateAndTime;
begin
  // Kombinieren des Datums und der Zeit von den Pickern
  CombinedDateTime := DateOf(DateTimePicker1.Date) + TimeOf(DateTimePicker2.Time);
  // Eine Stunde abziehen, um die Zeitkorrektur zu berücksichtigen
  CombinedDateTime := IncHour(CombinedDateTime, -1);
  // Zeigen Sie das kombinierte Datum und die Zeit an oder verwenden Sie es wie benötigt
  // ShowMessage('Das ausgewählte Datum und Zeit: ' + DateTimeToStr(CombinedDateTime));
end;



procedure TForm1.Button2Click(Sender: TObject);
begin
  addEvent;
end;

procedure TForm1.btnShowCalendarClick(Sender: TObject);
begin
  ShowAvailableCalendars;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  addToolbar;
  DateTimePicker2.DateTime := now;
  //handler := @AccessCompletionHandler;

end;


procedure TForm1.addToolbar;
var
  toolbar: TMacToolbar;
  item: TMacToolbarItem;
begin
  toolbar := TMacToolbar.Create(Self);
  //item := toolbar.Items.AddItem('refreshToolbarItem', 'Refresh',
  //  'Refresh', Self.AddCalendarEntry);
  //item.ImageDefaulType := NSImageNameRefreshTemplate;

  //item := toolbar.Items.AddItem('saveAllChangesItem', 'Save', 'Save',
  //  Self.SaveAllChanges);
  //item.ImageDefaulType := NSImageNameActionTemplate;
  //
  item := toolbar.Items.AddItem('Add Event', 'Add Event', 'Add', Self.AddCalendarEntry);
  item.ImageDefaulType := NSImageNameAddTemplate;
  //
  //item := toolbar.Items.AddItem('deleteSelectedFrame', 'Delete',
  //  'Delete', Self.DeleteSelectedFrame);
  //item.ImageDefaulType := NSImageNameRemoveTemplate;



  toolbar.Attach;
end;

procedure TForm1.ShowAvailableCalendars;
var
  eventStore: EKEventStore;
  calendars: NSArray;
  calendar: EKCalendar;
  entityType: EKEntityType;
  i: integer;
begin
  eventStore := EKEventStore.alloc.init;
  ListBox1.Clear;


  // Fordern Sie Zugriff auf den Ereigniskalender an
  //eventStore.requestAccessToEntityType_completion(EKEntityTypeEvent, @AccessCompletionHandler);
  store.requestAccessToEntityType_completion(EKEntityTypeEvent, handler);
  // Hier angenommen, dass der Zugriff bereits gewährt wurde, für die Demonstration
  entityType := EKEntityTypeEvent; // oder EKEntityTypeReminder für Erinnerungen
  calendars := eventStore.calendarsForEntityType(entityType);

  // Durchlaufen der Kalender und Ausgeben ihrer Titel
  for i := 0 to calendars.Count - 1 do
  begin
    //  calendar := EKCalendar.wrap(calendars.objectAtIndex(i));
    calendar := calendars.objectAtIndex(i);
    Listbox1.Items.Add(calendar.calendarIdentifier.utf8string);

    ListBox1.Items.Add(calendar.title.utf8string);
    // ShowMessage('Kalender: ' + calendar.title.UTF8String);
  end;

  eventStore.Release;
end;

procedure TForm1.AccessCompletionHandler(granted: boolean; error: NSError);
begin
  if granted then
  begin
    // Zugriff gewährt, Kalender abfragen
    ShowAvailableCalendars;
  end
  else
  begin
    // Zugriff verweigert, Benutzer benachrichtigen
    ShowMessage('Zugriff auf Kalender verweigert.');
  end;
end;

procedure TForm1.addEvent;
var
  DauerInMinuten: integer;
  success: boolean;
  error: NSErrorPtr; // Lokaler Fehlerzeiger
  interval: NSTimeInterval;
  startDate: NSDate;
  endDate: NSDate;
  event: EKEvent;
  eventStore: EKEventStore; // Lokale Variable eventStore korrekt initialisieren
begin
  // Überprüfen, welches Element ausgewählt wurde, basierend auf dem ItemIndex
  case ComboBox1.ItemIndex of
    0: DauerInMinuten := 30;
    1: DauerInMinuten := 45;
    2: DauerInMinuten := 60;

    else
      DauerInMinuten := 30; // Standardwert, falls keine gültige Auswahl getroffen wurde
  end;

  // Kombinieren des Datums und der Zeit in CombinedDateTime
  CombineDateAndTime;

  // Konvertierung von TDateTime (CombinedDateTime) in NSDate für startDate
  startDate := NSDate.dateWithTimeIntervalSince1970(
    (CombinedDateTime - UnixDateDelta) * SecsPerDay);



  error := nil; // Fehlerzeiger auf nil setzen

  eventStore := EKEventStore.alloc.init; // Initialisieren des EventStores
  event := EKEvent.eventWithEventStore(eventStore); // Erstellen eines neuen Events

  // Setzen der Event-Eigenschaften
  interval := 60 * DauerInMinuten; // 1 Stunde

  endDate := NSDate.dateWithTimeInterval_sinceDate(interval, startDate);

  event.setCalendar(eventStore.defaultCalendarForNewEvents);
  event.setTitle(NSSTR(EdEventName.Text));
  event.setNotes(NSSTR(Memo1.Text));

  event.setStartDate(startdate);
  event.setEndDate(endDate);

  // Versuchen, das Event zu speichern
  success := eventStore.saveEvent_span_commit_error(event, EKSpanThisEvent,
    True, @error);
  if not success then
  begin
    if Assigned(error) then
      ShowMessage('Fehler beim Speichern des Ereignisses: ' +
        NSString(error^.localizedDescription).utf8string)
    else
      ShowMessage('Unbekannter Fehler beim Speichern des Ereignisses.');
  end
  else
    ShowMessage('Ereignis erfolgreich gespeichert.');

  eventStore.Release; // Geben Sie den EventStore frei, wenn er nicht mehr benötigt wird
end;




procedure TForm1.Button1Click(Sender: TObject);
begin
  store := EKEventStore.alloc.init;
  store.requestAccessToEntityType_completion(EKEntityTypeEvent, handler);
end;

procedure TForm1.AddCalendarEntryExecute(Sender: TObject);
begin
  addEvent;

end;

end.
